#include <iostream>

struct my_exception {};

struct thing {
	int id;
	thing(int id) : id(id) { std::cout << id << " created\n"; }
	~thing() { std::cout << id << " destroyed\n"; }
};

struct base {
	thing t1 = { 1 };
	base() { std::cout << "base created\n"; }
	~base() { std::cout << "base destroyed\n"; }
};

struct derived : base {
	thing t2 = { 2 };
	derived() {
		std::cout << "--- in derived ctor ---\n";
		throw my_exception{};
	}
	~derived() {
		std::cout << "derived destroyed\n";
	}
};

struct faulty_thing {
	faulty_thing() {
		std::cout << "initialisation fails\n";
		throw my_exception{};
	}
};

struct init_fail_a : base {
	thing t2 = { 2 };
	faulty_thing ft;
	thing t3 = { 3 };
	init_fail_a() {	std::cout << "you won't see this\n"; }
	~init_fail_a() { std::cout << "you won't see this\n"; }
};

struct init_fail_b : derived {
	thing t3 = { 3 };
	init_fail_b() {	std::cout << "you won't see this\n"; }
	~init_fail_b() { std::cout << "you won't see this\n"; }
};

struct with_log : base {
	thing t2;
	faulty_thing ft;
	thing t3;

	with_log()
	try : t2{ 2 }, t3{ 3 } {
		std::cout << "you won't see this\n";
	} catch (my_exception& e) {
		std::cout << "something bad happened\n";
		// implicit rethrow happens here!
	}
};


int main() {
	try {
		derived d;
	} catch (my_exception& e) {
		std::cout << "exception caught\n";
	}
	std::cout << "-------------------------\n";
	try {
		init_fail_a x;
	} catch (my_exception& e) {
		std::cout << "exception caught\n";
	}
	std::cout << "-------------------------\n";
	try {
		init_fail_b x;
	} catch (my_exception& e) {
		std::cout << "exception caught\n";
	}
	std::cout << "-------------------------\n";
	try {
		with_log x;
	} catch (my_exception& e) {
		std::cout << "exception caught\n";
	}
}
