#include <iostream>

struct my_exception {
	my_exception() { std::cout << "created\n"; }
	~my_exception() { std::cout << "destroyed\n"; }
	my_exception(const my_exception&) { std::cout << "copied\n"; }
	my_exception(my_exception&&) { std::cout << "moved\n"; }
	my_exception& operator=(const my_exception&) {
		std::cout << "copy-assigned\n";
		return *this;
	}
	my_exception& operator=(my_exception&&) {
		std::cout << "move-assigned\n";
		return *this;
	}
};

void fail() {
	std::cout << "in fail()\n";
	throw my_exception{};
}

void f() {
	try {
		std::cout << "in f()\n";
		fail();
	} catch (my_exception& e) {
		std::cout << "rethrow from f()\n";
		throw;
	}
}

void g() {
	try {
		std::cout << "in g()\n";
		f();
	} catch (...) {
		std::cout << "rethrow from g()\n";
		throw;
	}
}

int main() {
	try {
		std::cout << "in main()\n";
		g();
	} catch (my_exception& e) {
		std::cout << "caught\n";
	}
	std::cout << "after try\n";
}
